#include <hxcpp.h>

#ifndef INCLUDED_snow_types_SystemEventType
#include <snow/types/SystemEventType.h>
#endif
namespace snow{
namespace types{

::snow::types::SystemEventType SystemEventType_obj::app_didenterbackground;

::snow::types::SystemEventType SystemEventType_obj::app_didenterforeground;

::snow::types::SystemEventType SystemEventType_obj::app_lowmemory;

::snow::types::SystemEventType SystemEventType_obj::app_terminating;

::snow::types::SystemEventType SystemEventType_obj::app_willenterbackground;

::snow::types::SystemEventType SystemEventType_obj::app_willenterforeground;

::snow::types::SystemEventType SystemEventType_obj::file;

::snow::types::SystemEventType SystemEventType_obj::init;

::snow::types::SystemEventType SystemEventType_obj::input;

::snow::types::SystemEventType SystemEventType_obj::quit;

::snow::types::SystemEventType SystemEventType_obj::ready;

::snow::types::SystemEventType SystemEventType_obj::shutdown;

::snow::types::SystemEventType SystemEventType_obj::unknown;

::snow::types::SystemEventType SystemEventType_obj::update;

::snow::types::SystemEventType SystemEventType_obj::window;

HX_DEFINE_CREATE_ENUM(SystemEventType_obj)

int SystemEventType_obj::__FindIndex(::String inName)
{
	if (inName==HX_CSTRING("app_didenterbackground")) return 11;
	if (inName==HX_CSTRING("app_didenterforeground")) return 13;
	if (inName==HX_CSTRING("app_lowmemory")) return 9;
	if (inName==HX_CSTRING("app_terminating")) return 8;
	if (inName==HX_CSTRING("app_willenterbackground")) return 10;
	if (inName==HX_CSTRING("app_willenterforeground")) return 12;
	if (inName==HX_CSTRING("file")) return 14;
	if (inName==HX_CSTRING("init")) return 1;
	if (inName==HX_CSTRING("input")) return 6;
	if (inName==HX_CSTRING("quit")) return 7;
	if (inName==HX_CSTRING("ready")) return 2;
	if (inName==HX_CSTRING("shutdown")) return 4;
	if (inName==HX_CSTRING("unknown")) return 0;
	if (inName==HX_CSTRING("update")) return 3;
	if (inName==HX_CSTRING("window")) return 5;
	return super::__FindIndex(inName);
}

int SystemEventType_obj::__FindArgCount(::String inName)
{
	if (inName==HX_CSTRING("app_didenterbackground")) return 0;
	if (inName==HX_CSTRING("app_didenterforeground")) return 0;
	if (inName==HX_CSTRING("app_lowmemory")) return 0;
	if (inName==HX_CSTRING("app_terminating")) return 0;
	if (inName==HX_CSTRING("app_willenterbackground")) return 0;
	if (inName==HX_CSTRING("app_willenterforeground")) return 0;
	if (inName==HX_CSTRING("file")) return 0;
	if (inName==HX_CSTRING("init")) return 0;
	if (inName==HX_CSTRING("input")) return 0;
	if (inName==HX_CSTRING("quit")) return 0;
	if (inName==HX_CSTRING("ready")) return 0;
	if (inName==HX_CSTRING("shutdown")) return 0;
	if (inName==HX_CSTRING("unknown")) return 0;
	if (inName==HX_CSTRING("update")) return 0;
	if (inName==HX_CSTRING("window")) return 0;
	return super::__FindArgCount(inName);
}

Dynamic SystemEventType_obj::__Field(const ::String &inName,bool inCallProp)
{
	if (inName==HX_CSTRING("app_didenterbackground")) return app_didenterbackground;
	if (inName==HX_CSTRING("app_didenterforeground")) return app_didenterforeground;
	if (inName==HX_CSTRING("app_lowmemory")) return app_lowmemory;
	if (inName==HX_CSTRING("app_terminating")) return app_terminating;
	if (inName==HX_CSTRING("app_willenterbackground")) return app_willenterbackground;
	if (inName==HX_CSTRING("app_willenterforeground")) return app_willenterforeground;
	if (inName==HX_CSTRING("file")) return file;
	if (inName==HX_CSTRING("init")) return init;
	if (inName==HX_CSTRING("input")) return input;
	if (inName==HX_CSTRING("quit")) return quit;
	if (inName==HX_CSTRING("ready")) return ready;
	if (inName==HX_CSTRING("shutdown")) return shutdown;
	if (inName==HX_CSTRING("unknown")) return unknown;
	if (inName==HX_CSTRING("update")) return update;
	if (inName==HX_CSTRING("window")) return window;
	return super::__Field(inName,inCallProp);
}

static ::String sStaticFields[] = {
	HX_CSTRING("unknown"),
	HX_CSTRING("init"),
	HX_CSTRING("ready"),
	HX_CSTRING("update"),
	HX_CSTRING("shutdown"),
	HX_CSTRING("window"),
	HX_CSTRING("input"),
	HX_CSTRING("quit"),
	HX_CSTRING("app_terminating"),
	HX_CSTRING("app_lowmemory"),
	HX_CSTRING("app_willenterbackground"),
	HX_CSTRING("app_didenterbackground"),
	HX_CSTRING("app_willenterforeground"),
	HX_CSTRING("app_didenterforeground"),
	HX_CSTRING("file"),
	::String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(SystemEventType_obj::app_didenterbackground,"app_didenterbackground");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::app_didenterforeground,"app_didenterforeground");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::app_lowmemory,"app_lowmemory");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::app_terminating,"app_terminating");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::app_willenterbackground,"app_willenterbackground");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::app_willenterforeground,"app_willenterforeground");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::file,"file");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::init,"init");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::input,"input");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::quit,"quit");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::ready,"ready");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::shutdown,"shutdown");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::unknown,"unknown");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::update,"update");
	HX_MARK_MEMBER_NAME(SystemEventType_obj::window,"window");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatic(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::app_didenterbackground,"app_didenterbackground");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::app_didenterforeground,"app_didenterforeground");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::app_lowmemory,"app_lowmemory");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::app_terminating,"app_terminating");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::app_willenterbackground,"app_willenterbackground");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::app_willenterforeground,"app_willenterforeground");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::file,"file");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::init,"init");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::input,"input");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::quit,"quit");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::ready,"ready");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::shutdown,"shutdown");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::unknown,"unknown");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::update,"update");
	HX_VISIT_MEMBER_NAME(SystemEventType_obj::window,"window");
};
#endif

static ::String sMemberFields[] = { ::String(null()) };
Class SystemEventType_obj::__mClass;

Dynamic __Create_SystemEventType_obj() { return new SystemEventType_obj; }

void SystemEventType_obj::__register()
{

hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.types.SystemEventType"), hx::TCanCast< SystemEventType_obj >,sStaticFields,sMemberFields,
	&__Create_SystemEventType_obj, &__Create,
	&super::__SGetClass(), &CreateSystemEventType_obj, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatic
#endif
#ifdef HXCPP_SCRIPTABLE
    , 0
#endif
);
}

void SystemEventType_obj::__boot()
{
hx::Static(app_didenterbackground) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("app_didenterbackground"),11);
hx::Static(app_didenterforeground) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("app_didenterforeground"),13);
hx::Static(app_lowmemory) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("app_lowmemory"),9);
hx::Static(app_terminating) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("app_terminating"),8);
hx::Static(app_willenterbackground) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("app_willenterbackground"),10);
hx::Static(app_willenterforeground) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("app_willenterforeground"),12);
hx::Static(file) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("file"),14);
hx::Static(init) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("init"),1);
hx::Static(input) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("input"),6);
hx::Static(quit) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("quit"),7);
hx::Static(ready) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("ready"),2);
hx::Static(shutdown) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("shutdown"),4);
hx::Static(unknown) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("unknown"),0);
hx::Static(update) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("update"),3);
hx::Static(window) = hx::CreateEnum< SystemEventType_obj >(HX_CSTRING("window"),5);
}


} // end namespace snow
} // end namespace types
